unit DataList;

interface

uses Classes, IntList;
  
const
  MaxNameLength = 31;

type
  TNamedList = class(TIntList)
   private
    FName: array[0..MaxNameLength-1] of char;
   public
    procedure SetName(aName:string);
    function GetName:string;
   end;

  TMemberList = class(TList)
   public
    procedure AddMember(aName:string);
    function GetMember(aName:string):TNamedList; overload;
    function GetMember(index: integer):TNamedList; overload;
    destructor Destroy; override;
   end;

implementation

{ TNamedList }

function TNamedList.GetName: string;
begin
  Result:=FName;
end;

procedure TNamedList.SetName;
var
  _i:integer;
begin
  for _i:=0 to MaxNameLength-1 do
   FName[_i]:=aName[_i+1];
end;

{ TObjList }

procedure TMemberList.AddMember(aName: string);
var
  _Lst:TNamedList;
begin
  if GetMember(aName)=nil then
   begin
    _Lst:=TNamedList.create;
    _Lst.SetName(aName);
    Add(_Lst);
   end;
end;


destructor TMemberList.Destroy;
var
  _i:integer;
begin
  for _i:=0 to Count-1 do
   TNamedList(Items[_i]).Free;
  inherited;
end;

function TMemberList.GetMember(aName: string): TNamedList;
var
  _i:integer;
begin
  Result:=nil;
  for _i:=0 to Count-1 do
   if TNamedList(Items[_i]).GetName = aName then
    begin
     Result:=TNamedList(Items[_i]);
     exit;
    end;
end;

function TMemberList.GetMember(index: integer): TNamedList;
begin
  Result:= TNamedList(Items[index]);
end;

end.
