library FortUI;

uses
  SysUtils,
  Classes,
  Windows,
  FortressCommonDefs,
  DLLForm_Unit in 'DLLForm_Unit.pas' {FormFromDLL};

{$R *.res}                       

var
  FormHandle:THandle;
  FormThreadID:DWORD;
  FormThreadHandle:THandle;

function StartGame(aPlayerNumber:integer; aAvailProjects: PAvailProjects; AGI:PAdditionalGameInfo):integer; stdcall;export;
var
  _i,_j:integer;
  _SyncEvent:THandle;
begin
  //MessageBox(0,'12312','123123',0);
  if aAvailProjects=nil then exit;

  _SyncEvent:= CreateEvent(0,true,false,'SyncEvent'); 

  FormFromDLL.Player:=aPlayerNumber;
  FormFromDLL.SyncEventHandle:=_SyncEvent;
  FormFromDLL.AGI:=AGI;

  SetForegroundWindow(FormHandle);
  SendMessage(FormHandle,WM_STARTGAME,0,0);
  WaitForSingleObject(_SyncEvent,INFINITE);
  CloseHandle(_SyncEvent);

  if FormFromDLL.PlayerTurn=-1 then exit;
  _j:=0;
  for _i:=0 to FormFromDLL.AvailProjectsListBox.Count-1 do
   if FormFromDLL.AvailProjectsListBox.Selected[_i] then
    begin
     aAvailProjects[_j]:=_i+1;
     _j:=_j+1;
    end;
end;

function GetTurn(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _SyncEvent:THandle;
begin
  Result:=0;
  if aAvailProjects=nil then exit;   

  _SyncEvent:= CreateEvent(0,true,false,'SyncEvent');

  FormFromDLL.Player:=aPlayerNumber;
  FormFromDLL.SyncEventHandle:=_SyncEvent;
  FormFromDLL.GameInfo:=aGame;
  FormFromDLL.AvailProjects:=aAvailProjects;
  FormFromDLL.AGI:=AGI;
  
  SetForegroundWindow(FormHandle);
  SendMessage(FormHandle,WM_GETTURN,0,0);
  WaitForSingleObject(_SyncEvent,INFINITE);
  CloseHandle(_SyncEvent);            
  //MessageBox(0,'SSSSS','SSSSSS',0);
  Result:=FormFromDLL.PlayerTurn;
end;

function ShowGame(aGame:PGame; Flags:DWORD; AGI:PAdditionalGameInfo):DWORD; stdcall; export;
{
       AGI.PreviousOpponentProject  
        

  
 0 -   ,  
 1 -  
 2 -     
}
var
  _SyncEvent:THandle;
begin
  _SyncEvent:= CreateEvent(0,true,false,'SyncEvent');

  FormFromDLL.GameInfo:=aGame;
  FormFromDLL.SyncEventHandle:=_SyncEvent;
  FormFromDLL.AGI:=AGI;

  SetForegroundWindow(FormHandle);
  SendMessage(FormHandle, WM_SHOWGAMEINFO, 0, 0);
  WaitForSingleObject(_SyncEvent, INFINITE);
  CloseHandle(_SyncEvent);
  //if IsFlagPresented(AGI) then
  Result:=DWORD(FormFromDLL.PlayerTurn);
end;

procedure ShowGameInterface; stdcall; export;
begin
  ShowWindow(FormFromDLL.Handle, SW_SHOWNORMAL);
end;

procedure HideGameInterface; stdcall; export;
begin
  ShowWindow(FormFromDLL.Handle,SW_HIDE);
end;

procedure SetPlayerNames(P1Name,P2Name:string); stdcall; export;
begin
  FormFromDLL.FirstPlayerName:=P1Name;
  FormFromDLL.SecondPlayerName:=P2Name;
end;



function ShowForm(PARAM1:DWORD):DWORD; stdcall;
begin
  FormFromDLL:=TFormFromDLL.Create(nil);
  FormHandle:=FormFromDLL.Handle;
  FormFromDLL.ShowModal;
end;

exports
 { GetName, }
 GetTurn,
 StartGame,
 ShowGameInterface,
 HideGameInterface,
 ShowGame,
 SetPlayerNames;

begin
  FormThreadHandle:=CreateThread(0,0,@showForm,0,0,FormThreadID);
end.
