unit IntList;

interface

uses sysutils, classes, windows;

type

  TIntList= class (TList)
    public
     procedure AddValue(Val:DWORD);
     procedure InsertValue(Index: integer; Val:DWORD);
     procedure SetValue(Ind:integer; Val:DWORD);
     function GetValue(Ind:integer):DWORD;
     procedure Copy(aIntList: TIntList); virtual;
     function Compare(aIntList:TIntList):integer;
     procedure AddToBack(aIntList: TIntList);
     function GetAsStrArray(aInfPoints:TIntList=nil):string;
     function IndexOfVal(val:DWORD):integer;
     function GetSumm(LastInd:integer):DWORD;
   end;

implementation

{ TIntList }

procedure TIntList.AddToBack(aIntList: TIntList);
var
  _i:integer;
begin
  for _i:=0 to aIntList.Count-1 do
   AddValue(aIntList.GetValue(_i));
end;

procedure TIntList.AddValue(Val: DWORD);
begin
  Add(pointer(Val));
end;

function TIntList.Compare(aIntList:TIntList): integer;
{
 if result = 0 then marks are equal
}
var
  _i:integer;
begin
  Result:=-1;
  for _i:=0 to aIntList.Count-1 do
   if aIntList.GetValue(_i)<>GetValue(_i) then exit;
  Result:=0;
end;

procedure TIntList.Copy(aIntList: TIntList);
begin
  Assign(aIntList);
end;

function TIntList.GetAsStrArray(aInfPoints:TIntList=nil): string;
var
  _i:integer;
begin
  Result:='(';
  if Count<>0 then
   if Assigned(aInfPoints) then
    if aInfPoints.IndexOfVal(0)<>-1 then
     Result:=Result+'W'             else
     Result:=Result+inttostr(GetValue(0))
                           else
    Result:=Result+inttostr(GetValue(0));
  for _i:=1 to Count-1 do
   if Assigned(aInfPoints) then
    if aInfPoints.IndexOfVal(_i)<>-1 then
      Result:=Result+',W'           else
      Result:=Result+','+inttostr(GetValue(_i))
                           else
    Result:=Result+','+inttostr(GetValue(_i));
  Result:=Result+')';
end;

function TIntList.GetSumm(LastInd: integer): DWORD;
var
  _i:integer;
begin
  Result:=0;
  for _i:=0 to LastInd do
   Result:=Result+GetValue(_i);
end;

function TIntList.GetValue(Ind: integer): DWORD;
begin
  Result:=DWORD(Items[Ind]);
end;

function TIntList.IndexOfVal(val: DWORD): integer;
begin
  Result:=IndexOf(pointer(val))
end;

procedure TIntList.InsertValue(Index: integer; Val: DWORD);
begin
  Insert(Index,pointer(Val));
end;

procedure TIntList.SetValue(Ind: integer; Val: DWORD);
begin
  Items[Ind]:=pointer(Val);
end;

end.
