library crusader;

uses
  SysUtils,
  Classes,
  Windows,
  FortressCommonDefs,
  IntList,
  DataList;

{$R *.res}

function GetName:PChar; stdcall; export;
begin
  Result:='Crusader v2.3.1';
end;

const
  StrategiesCount = 8;
  STRATEGIES:array[0..StrategiesCount-1,0..MaxProjectsToPLayer-1] of integer =
  (
   (10, 13, 16, 17, 20, 21, 27, 32, 33, 34, 35, 44, 45, 46, 50),// -Alar    - 100%
   (5, 7, 16, 17, 18, 20, 21, 29, 31, 33, 34, 35, 38, 46, 48),  // -  ~61%
   (10, 11, 14, 16, 17, 20, 22, 27, 32, 33, 34, 35, 36, 45, 50), // -  ~70%
   (10, 11, 14, 16, 17, 20, 21, 27, 32, 33, 34, 35, 36, 44, 50),  // -JDredd
   (7, 11, 13, 14, 17, 18, 20, 28,29, 30, 32, 33, 34, 40, 46),  //
   (5, 6,  7, 11, 13, 18, 24, 25, 26, 27, 28, 33, 34, 39, 50),  //
   (8, 9, 11, 14, 16, 17, 18, 19, 20, 27, 33, 34, 35, 44, 46),  //
   (7, 13, 14, 15, 17, 20, 21, 24, 27, 33, 34, 35, 41, 44, 46)  // -
   );

  DefaultStrategyRating = 100;
  MaxStrategyRating = 500;
  MinStrategyRating = 1;
  StrategyRatingWinIncrement  = 6;
  StrategyRatingDrawIncrement = 1;
  StrategyRatingLoseIncrement = -7;

  ProjResRate:array[1..TotalProjectsCount,1..3] of integer=
  ({En,Me,El}
   {Attack}
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   {Attack2}
   (2,0,0),
   (0,2,0),
   (2,0,0),
   (2,0,0),
   (0,2,0),
   {Repair}
   (0,0,0),
   (0,0,0),
   (1,0,0),
   (0,1,0),
   (0,0,0),
   (0,1,0),
   (0,0,1),
   (1,1,0),
   {SpecAttack}
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (0,0,0),
   {SuperAttack}
   (1,0,0),
   (1,1,0),
   (1,1,0),
   (3,1,1),
   (1,1,0),
   {Development}
   (0,0,0),
   (0,0,0),
   (0,0,0),
   (1,1,1),
   (0,2,0),
   (2,0,0),
   (0,0,1),
   (0,1,0),
   {Espoinage}
   (0,0,0),
   (0,0,0),
   (0,0,1),
   (0,0,1),
   (0,0,1),
   (0,1,2),
   (0,0,2),
   (1,0,2),
   (0,0,2),
   (0,0,0)
   ); //  

var
  SelectedStrategy:integer = -1;
  StratKnowledgeBase:TMemberList;

  AgressionRate: Double;
  AgressiveProjRate: Double;
  SleepingRate: Double;
  SleepingProjRate: Double;

  OPP:integer;
  EnergyRate,MetalRate,ElementsRate:integer;

function AdvancedRandom(aIntList:TIntList):integer;
var
  _i:integer;
  _Summ,_val:DWORD;
begin
  _Summ:=aIntList.GetSumm(aIntList.Count-1);

  _val:=random(_Summ);

  if (_val<aIntList.GetValue(0)) then
   begin
    Result:=0;
    exit;
   end;
  for _i:=1 to aIntList.Count-1 do
   if (_val>=aIntList.GetSumm(_i-1)) and
      (_val<aIntList.GetSumm(_i)) then
    begin
     Result:=_i;
     exit;
    end;
end;

function SelectStrategy(aOppName:string):integer;
begin
  if aOppName=HUMAN_NAME then
   begin
    Result:=Random(StrategiesCount);
    exit;
   end;
  Result:=AdvancedRandom(StratKnowledgeBase.GetMember(aOppName));
end;

function StartGame(aPlayerNumber:integer; aAvailProjects: PAvailProjects; AGI:PAdditionalGameInfo):integer; stdcall;export;
var
  _i,_v:integer;
begin
  if aAvailProjects=nil then
   begin
    //MessageBox(0,Pchar(FloatToStr(AgressionRate)),'11',0) ;
    if AGI^.OpponentName<>HUMAN_NAME then
     begin
      if IsFlagPresented(AGI^.GameResult,GR_WIN) then
       begin
        _v:=StratKnowledgeBase.GetMember(AGI^.OpponentName).GetValue(SelectedStrategy);
        _v:=_v+StrategyRatingWinIncrement;
        if _v>MaxStrategyRating then _v:=MaxStrategyRating;
        if _v<MinStrategyRating then _v:=MinStrategyRating;
        StratKnowledgeBase.GetMember(AGI^.OpponentName).SetValue(SelectedStrategy,_v);
       end;
      if IsFlagPresented(AGI^.GameResult,GR_Draw) then
       begin
        _v:=StratKnowledgeBase.GetMember(AGI^.OpponentName).GetValue(SelectedStrategy);
        _v:=_v+StrategyRatingDrawIncrement;
        if _v>MaxStrategyRating then _v:=MaxStrategyRating;
        if _v<MinStrategyRating then _v:=MinStrategyRating;
        StratKnowledgeBase.GetMember(AGI^.OpponentName).SetValue(SelectedStrategy,_v);
       end;
      if (IsFlagPresented(AGI^.GameResult,GR_FirstLose) and (aPlayerNumber=0)) or
         (IsFlagPresented(AGI^.GameResult,GR_SecondLose) and (aPlayerNumber=1)) then
       begin
        _v:=StratKnowledgeBase.GetMember(AGI^.OpponentName).GetValue(SelectedStrategy);
        _v:=_v+StrategyRatingLoseIncrement;
        if _v>MaxStrategyRating then _v:=MaxStrategyRating;
        if _v<MinStrategyRating then _v:=MinStrategyRating;
        StratKnowledgeBase.GetMember(AGI^.OpponentName).SetValue(SelectedStrategy,_v);
       end;
     end;
    //MessageBox(0,pchar(StratKnowledgeBase.GetMember(AGI^.OpponentName).GetAsStrArray()),'strat',0);
    exit;
   end;

  if StratKnowledgeBase.GetMember(AGI^.OpponentName)=nil then
   begin
    StratKnowledgeBase.AddMember(AGI^.OpponentName);
    for _i:=0 to StrategiesCount-1 do
     StratKnowledgeBase.GetMember(AGI^.OpponentName).AddValue(DefaultStrategyRating);
   end;

  AgressionRate:=0.999;
  AgressiveProjRate:=0;
  SleepingRate:=0;
  SleepingProjRate:=0;
  SelectedStrategy:=SelectStrategy(AGI^.OpponentName);
  //SelectedStrategy:=2 ;
  for _i:=0 to MaxProjectsToPLayer-1 do
   aAvailProjects^[_i]:=STRATEGIES[SelectedStrategy,_i];
   
  EnergyRate:=0;
  MetalRate:=0;
  ElementsRate:=0;
  for _i:=0 to MaxProjectsToPlayer-1 do
   begin
    EnergyRate:=EnergyRate+ProjResRate[STRATEGIES[SelectedStrategy,_i],1];
    MetalRate:=MetalRate+ProjResRate[STRATEGIES[SelectedStrategy,_i],2];
    ElementsRate:=ElementsRate+ProjResRate[STRATEGIES[SelectedStrategy,_i],3];
   end;
  {MessageBox(0,pchar(IntToStr(EnergyRate)),'energy',0);
  MessageBox(0,pchar(IntToStr(MetalRate)),'metal',0);
  MessageBox(0,pchar(IntToStr(ElementsRate)),'elements',0); }
end;

function IsProjectAvail(aProject:integer;aAvailProjects: PAvailProjects):boolean;
var
  _i:integer;
begin
  Result:=false;
  for _i:=0 to MaxProjectsToPLayer-1 do
   if aAvailProjects^[_i]=aProject then
    begin
     Result:=true;
     exit;
    end;
end;

const
  BuildBatteryProject = 33;
  BuildMineProject = 34;
  BuildLabProject = 35;
  BuildMineBatteryProject = 36;
  BuildLabProjectEx = 37;

const
  TA_ANY            =$FFFFFFFF;
  TA_Attack         =$00000001;
  TA_Build          =$00000002;
  TA_Repair         =$00000004;
  TA_Espionage      =$00000008;
  TA_RepairCritical =$00000010;
  TA_BuildCritical  =$00000020;
  TA_SleepTurn      =$00000040;

// Tacktik functions

function TtkGetTurnRepairCritical(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i:integer;
begin
  Result:=0;
  //MessageBox(0,'RepairCritical','RepairCritical',0);
  for _i:=22 downto 20 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  if IsProjectAvail(19,aAvailProjects) and
   (aGame[aPlayerNumber].Shield>6) then
   begin
    Result:=19;
    exit;
   end;
  if IsProjectAvail(17,aAvailProjects) then
   begin
    Result:=17;
    exit;
   end;
  if IsProjectAvail(16,aAvailProjects) then
   begin
    Result:=16;
    exit;
   end;
  if IsProjectAvail(18,aAvailProjects) then
   begin
    Result:=18;
    exit;
   end;
  if IsProjectAvail(15,aAvailProjects) then
   begin
    Result:=15;
    exit;
   end;
end;

function TtkGetTurnRepair(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
begin
  Result:=0;
  //MessageBox(0,'Repair','Repair',0);
  if IsProjectAvail(22,aAvailProjects) then
   begin
    Result:=22;
    exit;
   end;
  if (aGame[aPlayerNumber].Shield=0) and
     IsProjectAvail(17,aAvailProjects) then
   begin
    Result:=17;
    exit;
   end;
  if (aGame[aPlayerNumber].Shield=0) and
     IsProjectAvail(16,aAvailProjects) then
   begin
    Result:=16;
    exit;
   end;

  if IsProjectAvail(21,aAvailProjects) then
   begin
    Result:=21;
    exit;
   end;
  if IsProjectAvail(20,aAvailProjects) then
   begin
    Result:=20;
    exit;
   end;
  if IsProjectAvail(19,aAvailProjects) and
   (aGame[aPlayerNumber].Shield>12) then
   begin
    Result:=19;
    exit;
   end;
  if IsProjectAvail(17,aAvailProjects) then
   begin
    Result:=17;
    exit;
   end;
  if IsProjectAvail(18,aAvailProjects) then
   begin
    Result:=18;
    exit;
   end;
end;

function TtkGetTurnBuildCritical(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
begin
  Result:=0;
  //MessageBox(0,'BuildCritical','BuildCritical',0);
  if IsProjectAvail(BuildMineBatteryProject,aAvailProjects) and
     ((aGame[aPlayerNumber].Battery<5) or
      (aGame[aPlayerNumber].Mines<4)) then
   begin
    Result:=BuildMineBatteryProject;
    exit;
   end;
  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<3) then
   begin
    //MessageBox(0,'CCCC','CCCC',0);
    Result:=BuildMineProject;
    exit;
   end;   
  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<4) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;
  if IsProjectAvail(BuildLabProjectEx,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<3) then
   begin
    Result:=BuildLabProjectEx;
    exit;
   end;
  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<3) then
   begin
    Result:=BuildLabProject;
    exit;
   end;
end;

function TtkCheckBigAttack(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i,_j:integer;
  _nE,_nM,_nEl:Integer;
begin
  Result:=0;
  if SleepingRate>0.25 then exit;
  if not IsProjectAvail(50, aAvailProjects) then exit;
  _nE:=aGame[aPlayerNumber].Energy+aGame[aPlayerNumber].Battery+1;
  _nM:=aGame[aPlayerNumber].Metal+aGame[aPlayerNumber].Mines+1;
  _nEl:=aGame[aPlayerNumber].Elements+aGame[aPlayerNumber].Labs+1;
  for _i:=32 downto 29 do
   begin
    if IsProjectAvail(_i,aAvailProjects) then
     begin
      Result:=_i;
      exit;
     end;
    for _j:=0 to MaxProjectsToPlayer-1 do
     if STRATEGIES[SelectedStrategy,_j]=_i then
      if (_nE>=ProjectsData[_i,1]) and
         (_nM>=ProjectsData[_i,2]) and
         (_nEl>=ProjectsData[_i,3]) then
       begin
        //MessageBox(0,'check big attack','check big attack',0);
        Result:=50;
        exit;
       end;
   end;
  for _i:=48 downto 47 do
   begin
    if IsProjectAvail(_i,aAvailProjects) and
       (aGame[OPP].Shield<15) then
     begin
      Result:=_i;
      exit;
     end;
    for _j:=0 to MaxProjectsToPlayer-1 do
     if STRATEGIES[SelectedStrategy,_j]=_i then
      if (_nE>=ProjectsData[_i,1]) and
         (_nM>=ProjectsData[_i,2]) and
         (_nEl>=ProjectsData[_i,3]) then
       begin
        //MessageBox(0,'check big attack','check big attack',0);
        Result:=50;
        exit;
       end;
   end;
end;

function TtkGetTurnBuild(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
label REP;
var
  FirstNeededRes,SecondNeededRes:integer;
  _i:integer;
  _LabLimit:Integer;
  _TmpMetalRate:integer;
begin
  Result:=0;
  //MessageBox(0,'Build','Build',0);
  Result:=TtkCheckBigAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result<>0 then exit;
    
  if IsProjectAvail(BuildMineBatteryProject,aAvailProjects) then
   begin
    //MessageBox(0,'MBMB','MBMB',0);
    Result:=BuildMineBatteryProject;
    exit;
   end;
  _TmpMetalRate:=MetalRate;
REP:
  if (_TmpMetalRate>=EnergyRate) and (_TmpMetalRate>=ElementsRate) then FirstNeededRes:=2;
  if (EnergyRate>=_TmpMetalRate) and (EnergyRate>=ElementsRate) then FirstNeededRes:=1;  
  if (ElementsRate>=EnergyRate) and (ElementsRate>=_TmpMetalRate) then FirstNeededRes:=3;

  if (FirstNeededRes=2) and
     (aGame[aPlayerNumber].Mines-1>aGame[aPlayerNumber].Battery) and
     (aGame[aPlayerNumber].Mines-2>aGame[aPlayerNumber].Labs) then
   begin
    //MessageBox(0,'Repeat','Repeat',0);
    _TmpMetalRate:=0;
    goto REP;
   end;
   
  if FirstNeededRes=1 then
   begin
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
    SecondNeededRes:=2;
    if ElementsRate>=_TmpMetalRate then SecondNeededRes:=3;
   end;

  if FirstNeededRes=2 then
   begin
    if IsProjectAvail(BuildMineProject,aAvailProjects) then
     begin
      //MessageBox(0,'FFFF','FFFF',0);
      Result:=BuildMineProject;
      exit;
     end;
    SecondNeededRes:=1;
    if ElementsRate>=EnergyRate then SecondNeededRes:=3;
   end;

  if FirstNeededRes=3 then
   begin
    _LabLimit := (((aGame[aPlayerNumber].Base-3)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
    if (aGame[aPlayerNumber].Labs<_LabLimit) and
       IsProjectAvail(BuildLabProjectEx,aAvailProjects) then
     begin
      Result:=BuildLabProjectEx;
      exit;
     end;
    _LabLimit := (((aGame[aPlayerNumber].Base-6)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
    if (aGame[aPlayerNumber].Labs<_LabLimit) and
       IsProjectAvail(BuildLabProject,aAvailProjects) then
     begin
      Result:=BuildLabProject;
      exit;
     end;
    SecondNeededRes:=2;
    if EnergyRate>=_TmpMetalRate then SecondNeededRes:=1;
   end;

 if SecondNeededRes=1 then
   begin
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
   end;

  if SecondNeededRes=2 then
   begin
    if IsProjectAvail(BuildMineProject,aAvailProjects) then
     begin
      //MessageBox(0,'SSSS','SSSS',0);
      Result:=BuildMineProject;
      exit;
     end;
   end;

  if SecondNeededRes=3 then
   begin
    _LabLimit := (((aGame[aPlayerNumber].Base-6)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
    if (aGame[aPlayerNumber].Labs<_LabLimit) and
       IsProjectAvail(BuildLabProjectEx,aAvailProjects) then
     begin
      Result:=BuildLabProjectEx;
      exit;
     end;
    _LabLimit := (((aGame[aPlayerNumber].Base-12)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
    if (aGame[aPlayerNumber].Labs<_LabLimit) and
       IsProjectAvail(BuildLabProject,aAvailProjects) then
     begin
      Result:=BuildLabProject;
      exit;
     end;
   end;

  if IsProjectAvail(BuildMineProject,aAvailProjects) then
   begin
    Result:=BuildMineProject;
    exit;
   end;
  if IsProjectAvail(BuildBatteryProject,aAvailProjects) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end; 
  _LabLimit := (((aGame[aPlayerNumber].Base-6)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
  if IsProjectAvail(BuildLabProjectEx,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<_LabLimit) then
   begin
    Result:=BuildLabProjectEx;
    exit;
   end;
  _LabLimit := (((aGame[aPlayerNumber].Base-12)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit;
  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<_LabLimit) then
   begin
    Result:=BuildLabProject;
    exit;
   end;
end;

function TtkGetTurnAttack(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i:integer;
begin
  Result:=0;
  //MessageBox(0,'Attack','Attack',0);
  Result:=TtkCheckBigAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result<>0 then exit;
    
  if IsProjectAvail(31,aAvailProjects)  then
   begin
    Result:=31;
    exit;
   end;

  if IsProjectAvail(32,aAvailProjects)  then
   begin
    Result:=32;
    exit;
   end;

  if IsProjectAvail(30,aAvailProjects) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>20)  then
   begin
    Result:=30;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[OPP].Shield>7)  then
   begin
    Result:=29;
    exit;
   end;

  if IsProjectAvail(28,aAvailProjects) and
     (aGame[OPP].Shield>4)  then
   begin
    Result:=28;
    exit;
   end;

  if IsProjectAvail(27,aAvailProjects) and
   (aGame[OPP].Shield=0) then
   begin
    Result:=27;
    exit;
   end;
  for _i:=14 downto 10 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;
end;



function TtkFatalAttack(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i:integer;
begin
  Result:=0;
  //MessageBox(0,'fatal attack','fatal attack',0);    
  if IsProjectAvail(31,aAvailProjects) and
     (aGame[OPP].Base+aGame[OPP].Shield<50)  then
   begin
    Result:=31;
    exit;
   end;

  if IsProjectAvail(32,aAvailProjects) and
     (aGame[OPP].Base+aGame[OPP].Shield<31)  then
   begin
    Result:=32;
    exit;
   end;

  if IsProjectAvail(30,aAvailProjects) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>20) and
     (aGame[OPP].Base+aGame[OPP].Shield<50)  then
   begin
    Result:=30;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[OPP].Base<21)  then
   begin
    Result:=29;
    exit;
   end;

  if IsProjectAvail(28,aAvailProjects) and
     (aGame[OPP].Base<11)  then
   begin
    Result:=28;
    exit;
   end;

  if IsProjectAvail(27,aAvailProjects) and
   (aGame[OPP].Shield=0) and (aGame[OPP].Base<12) then
   begin
    Result:=27;
    exit;
   end;
   
  for _i:=14 downto 13 do
   if IsProjectAvail(_i,aAvailProjects) and
      (aGame[OPP].Base+aGame[OPP].Shield<_i+5) then
    begin
     Result:=_i;
     exit;
    end;

  if IsProjectAvail(12,aAvailProjects) and
     (aGame[OPP].Base+aGame[OPP].Shield<26) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>10)  then
   begin
    Result:=12;
    exit;
   end;

  for _i:=11 downto 10 do
   if IsProjectAvail(_i,aAvailProjects) and
      (aGame[OPP].Base+aGame[OPP].Shield<_i+5) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=9 downto 7 do
   if IsProjectAvail(_i,aAvailProjects) and
      (aGame[OPP].Base+aGame[OPP].Shield<11) then
    begin
     Result:=_i;
     exit;
    end;
end;

function TtkGetTurnEspionage(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i:integer;
begin
  Result:=0;
  //MessageBox(0,'Espionage','Espionage',0);
  Result:=TtkCheckBigAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result<>0 then exit;  
  if IsProjectAvail(47,aAvailProjects) and
   (aGame[OPP].Shield<15) and
   (aGame[OPP].Metal>10) then
   begin
    Result:=47;
    exit;
   end;
  if IsProjectAvail(48,aAvailProjects) and
   (aGame[OPP].Shield<15) and
   (aGame[OPP].Energy>11) then
   begin
    Result:=48;
    exit;
   end;
  if IsProjectAvail(49,aAvailProjects) and
   (aGame[OPP].Shield<10) then
   begin
    Result:=49;
    exit;
   end;
  if IsProjectAvail(46,aAvailProjects) and
   (aGame[OPP].Shield>7) then
   begin
    Result:=46;
    exit;
   end;

  if IsProjectAvail(44,aAvailProjects) and
   (aGame[OPP].Mines>2) then
   begin
    Result:=44;
    exit;
   end;
  if IsProjectAvail(45,aAvailProjects) and
   (aGame[OPP].Battery>3) then
   begin
    Result:=45;
    exit;
   end;
end;

function TtkGetTurnSleep(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer;
var
  _i:integer;
begin
  //MessageBox(0,'Sleep','Sleep',0);
  Result:=TtkCheckBigAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result<>0 then exit;
  
  for _i:=42 downto 41 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=32 downto 28 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=9 downto 1 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=14 downto 10 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=20 to 25 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  for _i:=18 downto 15 do
   if IsProjectAvail(_i,aAvailProjects) then
    begin
     Result:=_i;
     exit;
    end;

  if IsProjectAvail(50,aAvailProjects) then
   begin
    Result:=50;
    exit;
   end;
  //MessageBox(0,'RANDOM','RANDOM',0);
  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;

////
//// Strategies functions
////
{
   (9,11, 13, 16, 20, 22, 27, 31, 33, 34, 35, 44, 45, 46, 50)
     
}

function GetTurnUniversalStrategy(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
label
  ACTION;
const
  AgressionValue = 33/100;
var
  TurnAction:DWORD;
  PRSS,OPRSS:integer;
begin
  if aAvailProjects=nil then exit;

  OPP:=GetOtherPlayer(aPlayerNumber);
  PRSS:=aGame[aPlayerNumber].Battery+aGame[aPlayerNumber].Mines+aGame[aPlayerNumber].Labs;
  OPRSS:=aGame[OPP].Battery+aGame[OPP].Mines+aGame[OPP].Labs;

  TurnAction:=TA_ANY;

  TurnAction:=TA_RepairCritical;
  if (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<15) or
     (aGame[aPlayerNumber].Base<5) then
   goto ACTION;

  TurnAction:=TA_Repair;
  if (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<49) or
     ((aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<60) and (AgressionRate>=AgressionValue+0.33)) or
     (aGame[aPlayerNumber].Base<15) or
     ((aGame[aPlayerNumber].Shield<3) and (aGame[aPlayerNumber].Base<25)) or
     ((aGame[aPlayerNumber].Shield=0) and (aGame[aPlayerNumber].Base<33)) then
   goto ACTION;

  TurnAction:=TA_BuildCritical;
  if (PRSS<9) or (PRSS<OPRSS-2) or (AGI^.TurnCount<4) then goto ACTION;

  TurnAction:=TA_Build;
  if ((AgressionRate>=AgressionValue) and
     (PRSS<OPRSS+2)) then goto ACTION;

  TurnAction:=TA_Espionage;
  if (aGame[OPP].Base+aGame[OPP].Shield>35) or
     (aGame[OPP].Shield>15) or
     (OPRSS>8) or
     (aGame[aPlayerNumber].Elements>15) or
     (aGame[OPP].Metal+aGame[OPP].Energy+aGame[OPP].Elements>40) then
   goto ACTION;

  TurnAction:=TA_Attack;
  
ACTION:
  Result:=TtkFatalAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result<>0 then exit;
  if TurnAction=TA_RepairCritical then
   begin
    Result:=TtkGetTurnRepairCritical(aPlayerNumber,aGame,aAvailProjects,AGI);
   end;
  if TurnAction=TA_Repair then
   begin
    Result:=TtkGetTurnRepair(aPlayerNumber,aGame,aAvailProjects,AGI);
    if Result=0 then TurnAction:=TA_Build;
   end;
  if TurnAction=TA_BuildCritical then
   begin
    Result:=TtkGetTurnBuildCritical(aPlayerNumber,aGame,aAvailProjects,AGI);
    if Result=0 then Result:=TtkGetTurnBuild(aPlayerNumber,aGame,aAvailProjects,AGI);
   end;
  if TurnAction=TA_Build then
   begin
    Result:=TtkGetTurnBuild(aPlayerNumber,aGame,aAvailProjects,AGI);
    if Result=0 then Result:=TtkGetTurnRepair(aPlayerNumber,aGame,aAvailProjects,AGI);
   end;
  if TurnAction=TA_Espionage then
   begin
    Result:=TtkGetTurnEspionage(aPlayerNumber,aGame,aAvailProjects,AGI);
    if Result=0 then TurnAction:=TA_Attack;
   end;
  if TurnAction=TA_Attack then Result:=TtkGetTurnAttack(aPlayerNumber,aGame,aAvailProjects,AGI);
  if TurnAction=TA_ANY then Result:=TtkGetTurnSleep(aPlayerNumber,aGame,aAvailProjects,AGI);

  if Result=0 then Result:=TtkGetTurnSleep(aPlayerNumber,aGame,aAvailProjects,AGI);
  {if Result=BuildMineProject then
   MessageBox(0,'BMP','BMP',0);  }
end;

{
      MakpoBupyc'y
       ,      4 (31)
    (5, 7, 10, 16, 17, 18, 20, 31, 33, 34, 35, 38, 44, 46, 48)
}

function GetTurnStrategy2(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
const
  AgressionValue = 25/100;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(5,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<9) then
   begin
    Result:=5;
    exit;
   end;

  if IsProjectAvail(7,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=7;
    exit;
   end;

  if IsProjectAvail(10,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<15) then
   begin
    Result:=10;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[_OPP].Base<21) then
   begin
    Result:=29;
    exit;
   end;

  if IsProjectAvail(31,aAvailProjects) then
   begin
    Result:=31;
    exit;
   end;

/////
  if IsProjectAvail(21,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=21;
    exit;
   end;

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<17) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(17,aAvailProjects) and
     ((aGame[aPlayerNumber].Shield<12) or
      (aGame[aPlayerNumber].Shield+aGame[aPlayerNumber].Base<23)) then
   begin
    Result:=17;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(16,aAvailProjects) and
     (aGame[aPlayerNumber].Shield<2) then
   begin
    Result:=16;
    exit;
   end;

  if AgressionRate>AgressionValue then
   begin
    if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<4) and
     (aGame[aPlayerNumber].Base>25) then
   begin
    Result:=BuildMineProject;
    exit;
   end;

    if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<4) and
       (aGame[aPlayerNumber].Base>25) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
     
    if IsProjectAvail(BuildLabProject,aAvailProjects) and
       (aGame[aPlayerNumber].Labs<3) and
       (aGame[aPlayerNumber].Base>25) then
     begin
      Result:=BuildLabProject;
      exit;
     end;
  
  //  
    if IsProjectAvail(BuildMineProject,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<8) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
     begin
      Result:=BuildMineProject;
      exit;
     end;
  
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<6) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
  
    if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<5) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
     begin
      Result:=BuildLabProject;
      exit;
     end;
     //
  
    //    2
    if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<11) and
       (aGame[aPlayerNumber].Base>40) and
       (aGame[aPlayerNumber].Shield>8) then
     begin
      Result:=BuildMineProject;
      exit;
     end;
  
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<7) and
       (aGame[aPlayerNumber].Base>40) and
       (aGame[aPlayerNumber].Shield>8) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
   end;
  
   //----------
  if IsProjectAvail(48,aAvailProjects) and
     (aGame[_OPP].Energy>15) and
     (aGame[_OPP].Shield<15) then
   begin
    Result:=48;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[_OPP].Shield>7) then
   begin
    Result:=29;
    exit;
   end;
   
  if IsProjectAvail(46,aAvailProjects) and
     (aGame[_OPP].Shield>7) then
   begin
    Result:=46;
    exit;
   end;
   /////
  if IsProjectAvail(38,aAvailProjects) and
     (aGame[aPlayerNumber].Metal>20) then
   begin
    Result:=38;
    exit;
   end;

  if IsProjectAvail(21,aAvailProjects) and
     (aGame[aPlayerNumber].Base<50) then
   begin
    Result:=21;
    exit;
   end;

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<40) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;

{  if IsProjectAvail(BuildMineProject,aAvailProjects) then
   begin
    Result:=BuildMineProject;
    exit;
   end;  }  

  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;

{
    JDredd
}
 {
function GetTurnStrategy3(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
const
  AgressionValue = 33/100;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(8,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=8;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<16) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(13,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<18) then
   begin
    Result:=13;
    exit;
   end;

  if IsProjectAvail(14,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<19) then
   begin
    Result:=14;
    exit;
   end;

/////
  if IsProjectAvail(21,aAvailProjects) and
     (aGame[aPlayerNumber].Base<22) then
   begin
    Result:=21;
    exit;
   end;

  if IsProjectAvail(21,aAvailProjects) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<50) and
     (AGI^.TurnCount<3) then
   begin
    Result:=21;
    exit;
   end;

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<17) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(16,aAvailProjects) and
     (aGame[aPlayerNumber].Shield=0) then
   begin
    Result:=16;
    exit;
   end;

  if IsProjectAvail(47,aAvailProjects) and
     (aGame[_OPP].Shield<15) and
     (aGame[_OPP].Metal>10) then
   begin
    Result:=47;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[_OPP].Shield>5) then
   begin
    Result:=29;
    exit;
   end;

  if IsProjectAvail(32,aAvailProjects) then
   begin
    Result:=32;
    exit;
   end;

  if AgressionRate>=AgressionValue then
   begin
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<4) and
       (aGame[aPlayerNumber].Base>25) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
        
    if IsProjectAvail(BuildMineProject,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<3) and
       (aGame[aPlayerNumber].Base>25) then
     begin
      Result:=BuildMineProject;
      exit;
     end;

    if IsProjectAvail(BuildLabProject,aAvailProjects) and
       (aGame[aPlayerNumber].Labs<3) and
       (aGame[aPlayerNumber].Base>20) then
     begin
      Result:=BuildLabProject;
      exit;
     end;

    //  
    if IsProjectAvail(BuildLabProjectEx,aAvailProjects) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>30) and
       (aGame[aPlayerNumber].Labs<(((aGame[aPlayerNumber].Base-1)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit) then
     begin
      Result:=BuildLabProjectEx;
      exit;
     end;

    if IsProjectAvail(BuildMineProject,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<6) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
     begin
      Result:=BuildMineProject;
      exit;
     end;

    if IsProjectAvail(BuildLabProject,aAvailProjects) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>30) and
       (aGame[aPlayerNumber].Labs<(((aGame[aPlayerNumber].Base-6)-UnlimitLabsBaseValue) div UnlimitLabsStep) + BaseLabLimit) then
     begin
      Result:=BuildLabProject;
      exit;
     end;
     
    if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<8) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
     begin
      Result:=BuildBatteryProject;
      exit;
     end;
   end;

  if (aGame[aPlayerNumber].Energy+aGame[aPlayerNumber].Battery+1>=ProjectsData[29,1]) and
     (aGame[aPlayerNumber].Metal+aGame[aPlayerNumber].Mines+1>=ProjectsData[29,2]) and
     (aGame[aPlayerNumber].Elements+aGame[aPlayerNumber].Labs+1>=ProjectsData[29,3]) then
   begin
    Result:=50;
    exit;
   end;

  if (aGame[aPlayerNumber].Energy+aGame[aPlayerNumber].Battery+1>=ProjectsData[47,1]) and
     (aGame[aPlayerNumber].Elements+aGame[aPlayerNumber].Labs+1>=ProjectsData[47,3]) then
   begin
    Result:=50;
    exit;
   end;

  if AgressionRate<AgressionValue then
   begin
    if IsProjectAvail(44,aAvailProjects) and
       (aGame[_OPP].Mines>2) then
     begin
      Result:=44;
      exit;
     end;

    if IsProjectAvail(13,aAvailProjects) then
     begin
      Result:=13;
      exit;
     end;

    if IsProjectAvail(14,aAvailProjects) then
     begin
      Result:=14;
      exit;
     end;
   end;
   //
  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<65) and
     (AgressionRate>=AgressionValue) then
   begin
    Result:=20;
    exit;
   end;

  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;
    }
{
        
   (8, 11, 14, 18, 20, 21, 25, 27,32, 34, 35, 44, 45, 46, 48)
}
     {
function GetTurnStrategy4(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(25,aAvailProjects) and
     (aGame[_OPP].Base<8) then
   begin
    Result:=25;
    exit;
   end;

  if IsProjectAvail(27,aAvailProjects) and
     (aGame[_OPP].Shield=0) and
     (aGame[_OPP].Base<12) then
   begin
    Result:=27;
    exit;
   end;

  if IsProjectAvail(8,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=8;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<16) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(14,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<19) then
   begin
    Result:=14;
    exit;
   end;     
///// 
  if IsProjectAvail(21,aAvailProjects) and
     (aGame[aPlayerNumber].Base<25) then
   begin
    Result:=21;
    exit;
   end;

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<17) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(41,aAvailProjects) and
     (AGI^.TurnCount<3) then
   begin
    Result:=41;
    exit;
   end;

//
  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<4) and
     (aGame[aPlayerNumber].Base>35) then
   begin
    Result:=BuildMineProject;
    exit;
   end; 

  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<3) and
     (aGame[aPlayerNumber].Base>35) then
   begin
    Result:=BuildLabProject;
    exit;
   end;

  //  
  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<8) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
   begin
    Result:=BuildMineProject;
    exit;
   end;

  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Labs<5) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
   begin
    Result:=BuildLabProject;
    exit;
   end;
   //

  if IsProjectAvail(48,aAvailProjects) and
     (aGame[_OPP].Shield<15) and
     (aGame[_OPP].Energy>10) then
   begin
    Result:=48;
    exit;
   end;

  if IsProjectAvail(32,aAvailProjects) then
   begin
    Result:=32;
    exit;
   end;

   //----------
  if IsProjectAvail(46,aAvailProjects) and
     (aGame[_OPP].Shield>7) then
   begin
    Result:=46;
    exit;
   end;
   /////

  if IsProjectAvail(27,aAvailProjects) and
     (aGame[_OPP].Shield=0) then
   begin
    Result:=27;
    exit;
   end;

  if IsProjectAvail(44,aAvailProjects) and
     (aGame[_OPP].Mines>2) then
   begin
    Result:=44;
    exit;
   end;

  if IsProjectAvail(45,aAvailProjects) and
     (aGame[_OPP].Battery>3) then
   begin
    Result:=45;
    exit;
   end;
 //

   if IsProjectAvail(14,aAvailProjects) then
   begin
    Result:=14;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(BuildMineProject,aAvailProjects) then
   begin
    Result:=BuildMineProject;
    exit;
   end;

  if IsProjectAvail(25,aAvailProjects) then
   begin
    Result:=25;
    exit;
   end;  

  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;
       }
{
     
  (7, 11, 13, 14, 17, 18, 20, 28,29, 30, 32, 33, 34, 40, 46)
}

function GetTurnStrategy5(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(30,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<50) and
     (aGame[aPlayerNumber].Shield+aGame[aPlayerNumber].Base>20) then
   begin
    Result:=30;
    exit;
   end;

  if IsProjectAvail(7,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=7;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<16) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(13,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<18) then
   begin
    Result:=13;
    exit;
   end;

  
///// 
  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<20) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(17,aAvailProjects) and
     (aGame[aPlayerNumber].Shield<5) then
   begin
    Result:=17;
    exit;
   end;

//
  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<4) and
     (aGame[aPlayerNumber].Base>30) then
   begin
    Result:=BuildMineProject;
    exit;
   end; 

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<5) and
     (aGame[aPlayerNumber].Base>30) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;

  //  
  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<8) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;
   
  if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<8) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>40) then
   begin
    Result:=BuildMineProject;
    exit;
   end;
   //

  if IsProjectAvail(32,aAvailProjects) then
   begin
    Result:=32;
    exit;
   end;
   //----------
  if IsProjectAvail(46,aAvailProjects) and
     (aGame[_OPP].Shield>7) then
   begin
    Result:=46;
    exit;
   end;
   /////
  if IsProjectAvail(30,aAvailProjects) and
     (aGame[aPlayerNumber].Shield>5) and
     (aGame[aPlayerNumber].Base>30) then
   begin
    Result:=30;
    exit;
   end;

  if IsProjectAvail(29,aAvailProjects) and
     (aGame[_OPP].Shield>5) then
   begin
    Result:=29;
    exit;
   end;

  if IsProjectAvail(28,aAvailProjects) and
     (aGame[_OPP].Shield>5) then
   begin
    Result:=28;
    exit;
   end;

//
  if IsProjectAvail(40,aAvailProjects) and
     (aGame[aPlayerNumber].Metal>15) then
   begin
    Result:=40;
    exit;
   end;

   if IsProjectAvail(13,aAvailProjects) then
   begin
    Result:=13;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end;

  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;

{
  
  (5, 6,  7, 11, 13, 18, 24, 25, 26, 27, 28, 33, 34, 39, 50)
  
}

function GetTurnStrategy6(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(26,aAvailProjects) and
     (aGame[aPlayerNumber].Shield>5) then
   begin
    Result:=26;
    exit;
   end;

  if IsProjectAvail(5,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<9) then
   begin
    Result:=5;
    exit;
   end;

  if IsProjectAvail(6,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<9) then
   begin
    Result:=6;
    exit;
   end;

  if IsProjectAvail(7,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=7;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<16) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(13,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<18) then
   begin
    Result:=13;
    exit;
   end;

  
///// 
  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<5) then
   begin
    Result:=18;
    exit;
   end;

//
  {if IsProjectAvail(BuildMineProject,aAvailProjects) and
     (aGame[aPlayerNumber].Mines<4) and
     (aGame[aPlayerNumber].Base>30) then
   begin
    Result:=BuildMineProject;
    exit;
   end; 

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Battery<5) and
     (aGame[aPlayerNumber].Base>30) then
   begin
    Result:=BuildBatteryProject;
    exit;
   end; }

   /////


  if IsProjectAvail(27,aAvailProjects) and
     (aGame[_OPP].Shield=0) then
   begin
    Result:=27;
    exit;
   end;

//
   if IsProjectAvail(13,aAvailProjects) then
   begin
    Result:=13;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) then
   begin
    Result:=11;
    exit;
   end;

  {}

  if IsProjectAvail(39,aAvailProjects) and
     (aGame[aPlayerNumber].Elements>10) then
   begin
    Result:=39;
    exit;
   end;

  if IsProjectAvail(24,aAvailProjects) then
   begin
    Result:=24;
    exit;
   end;

  if IsProjectAvail(25,aAvailProjects) then
   begin
    Result:=25;
    exit;
   end;

  repeat
   Result:=aAvailProjects^[random(5)];
  until Result<>0;
end;

{         
}

function GetTurnStrategy7(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (AGI^.TurnCount<3) then
   begin
    Result:=BuildBatteryProject;
    Exit;
   end;

  if IsProjectAvail(8,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=8;
    exit;
   end;

  if IsProjectAvail(9,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<11) then
   begin
    Result:=9;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<16) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(14,aAvailProjects) and
     (aGame[_OPP].Base+aGame[_OPP].Shield<19) then
   begin
    Result:=14;
    exit;
   end;
  
///// 
  if IsProjectAvail(17,aAvailProjects) and
     (aGame[aPlayerNumber].Shield<25) then
   begin
    Result:=17;
    exit;
   end;

  if IsProjectAvail(20,aAvailProjects) and
     (aGame[aPlayerNumber].Base<17) then
   begin
    Result:=20;
    exit;
   end;

  if IsProjectAvail(18,aAvailProjects) and
     (aGame[aPlayerNumber].Base<30) then
   begin
    Result:=18;
    exit;
   end;

  if IsProjectAvail(16,aAvailProjects) and
     (aGame[aPlayerNumber].Shield<20) then
   begin
    Result:=16;
    exit;
   end;

  if IsProjectAvail(19,aAvailProjects) and
     (aGame[aPlayerNumber].Shield>12) and
     (aGame[aPlayerNumber].Base>12) then
   begin
    Result:=19;
    exit;
   end;

  if IsProjectAvail(BuildMineProject,aAvailProjects) {and
     (aGame[aPlayerNumber].Mines<10)} then
   begin
    Result:=BuildMineProject;
    Exit;
   end;

  if IsProjectAvail(BuildLabProject,aAvailProjects) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>30) then
   begin
    Result:=BuildLabProject;
    Exit;
   end;
  if IsProjectAvail(BuildBatteryProject,aAvailProjects) and
     (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>30) then
   begin
    Result:=BuildBatteryProject;
    Exit;
   end;

  if IsProjectAvail(14,aAvailProjects) then
   begin
    Result:=14;
    exit;
   end;

  if IsProjectAvail(11,aAvailProjects) then
   begin
    Result:=11;
    exit;
   end;

  if IsProjectAvail(27,aAvailProjects) and
     (aGame[_OPP].Shield=0) then
   begin
    Result:=27;
    exit;
   end;

  if IsProjectAvail(9,aAvailProjects) then
   begin
    Result:=9;
    exit;
   end;

  if IsProjectAvail(19,aAvailProjects) and
     (aGame[aPlayerNumber].Shield>5) then
   begin
    Result:=19;
    exit;
   end;

  repeat
   Result:=aAvailProjects^[random(7)];
  until Result<>0;
end;

{
  
  ( ,  ,  , 13, 14, 15, , 20, 27, 33, 34, 35, 41, , 46)
}

function GetTurnStrategy8(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;
const
  AgressionValue = 30/100;
var
  _OPP:Integer;
begin
  if aAvailProjects=nil then exit;
  _OPP:=GetOtherPlayer(aPlayerNumber);

    if IsProjectAvail(21,aAvailProjects) and
       ((aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<24) or
       (aGame[aPlayerNumber].Base<12)) and
       (AGI^.TurnCount>2)  then
     begin
      Result:= 21;
      exit;
     end;

    if IsProjectAvail(20,aAvailProjects) and
       ((aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<20) or
       (aGame[aPlayerNumber].Base<8)) and
       (AGI^.TurnCount>2)  then
     begin
      Result:= 20;
      exit;
     end;

    if IsProjectAvail(17,aAvailProjects) and
       ((aGame[aPlayerNumber].Shield<7) or
       (aGame[aPlayerNumber].Base<15)) and
       (AGI^.TurnCount>20) then
     begin
      Result:=17;
      exit;
     end;

    if IsProjectAvail(15,aAvailProjects) and
       ((aGame[aPlayerNumber].Shield<3) or
       (aGame[aPlayerNumber].Base<9)) and
       (AGI^.TurnCount>2) then
     begin
      Result:=15;
      exit;
     end;

    if (IsProjectAvail(41,aAvailProjects) and
       (aGame[_OPP].Metal>3) and
       (AGI^.TurnCount<3)) then
     begin
      Result:=41;
      exit;
     end;

  if AgressionRate>=AgressionValue then
   begin
    if IsProjectAvail(34,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<3) then
     begin
      Result:=34;
      exit;
     end;

    if IsProjectAvail(33,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<4) then
     begin
      Result:=33;
      exit;
     end;

    if IsProjectAvail(35,aAvailProjects) and
       (aGame[aPlayerNumber].Labs<3) then
     begin
      Result:=35;
      exit;
     end;

    //-----------  
    if (IsProjectAvail(34,aAvailProjects) and
       (aGame[aPlayerNumber].Mines<5) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>20)) then
     begin
      Result:=34;
      exit;
     end;

    if (IsProjectAvail(33,aAvailProjects) and
       (aGame[aPlayerNumber].Battery<6) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>20)) then
     begin
      Result:=33;
      exit;
     end;

    if (IsProjectAvail(35,aAvailProjects) and
       (aGame[aPlayerNumber].Labs<5) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield>20)) then
     begin
      Result:=35;
      exit;
     end;
   end;  
    //-----------------------------

    if (IsProjectAvail(46,aAvailProjects) and
       (aGame[_OPP].Shield>7)) then
     begin
      Result:=46;
      exit;
     end;

    if (IsProjectAvail(44,aAvailProjects) and
       (aGame[_OPP].Mines>2)) then
     begin
      Result:=44;
      exit;
     end;

    if (IsProjectAvail(27,aAvailProjects) and
       (aGame[_OPP].Shield=0)) then
     begin
      Result:=27;
      exit;
     end;

    if (IsProjectAvail(14,aAvailProjects)) then
     begin
      Result:=14;
      exit;
     end;

    if (IsProjectAvail(13,aAvailProjects)) then
     begin
      Result:=13;
      exit;
     end;

    if (IsProjectAvail(7,aAvailProjects)) then
     begin
      Result:=7;
      exit;
     end;

    if (IsProjectAvail(21,aAvailProjects)) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<27) and
       (AgressionRate>=AgressionValue) then
     begin
      Result:= 21;
      exit;
     end;

    if (IsProjectAvail(17,aAvailProjects)) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<25) and
       (AgressionRate>=AgressionValue) then
     begin
      Result:= 17;
      exit;
     end;

    if (IsProjectAvail(20,aAvailProjects)) and
       (aGame[aPlayerNumber].Base+aGame[aPlayerNumber].Shield<25) and
       (AgressionRate>=AgressionValue) then
     begin
      Result:= 20;
      exit;
     end;

    if (IsProjectAvail(24,aAvailProjects)) then
     begin
      Result:=24;
      exit;
     end;

    if IsProjectAvail(41,aAvailProjects) and
       (aGame[_OPP].Metal>3) then
     begin
      Result:=41;
      exit;
     end;

    repeat
     Result:=aAvailProjects^[random(7)];
    until Result<>0;
end;

const
   StrategiesFunctions:array[0..StrategiesCount-1] of TPlayerTurnFunc =
   (
    GetTurnUniversalStrategy,
    GetTurnStrategy2,
    GetTurnUniversalStrategy,
    GetTurnUniversalStrategy,
    GetTurnStrategy5,
    GetTurnStrategy6,
    GetTurnStrategy7,
    GetTurnStrategy8
    );

function GetTurn(aPlayerNumber:integer; aGame:PGame; aAvailProjects: PAvailProjects;
  AGI:PAdditionalGameInfo):integer; stdcall; export;      
begin
  Result:=StrategiesFunctions[SelectedStrategy](aPlayerNumber,aGame,aAvailProjects,AGI);
  if Result in [1..9] then AgressiveProjRate:=AgressiveProjRate+0.9;
  if Result in [10..14,26..28] then AgressiveProjRate:=AgressiveProjRate+1;
  if Result in [29..32] then AgressiveProjRate:=AgressiveProjRate+2;
  if Result in [46..49] then AgressiveProjRate:=AgressiveProjRate+1.25;
  if Result in [44..45] then AgressiveProjRate:=AgressiveProjRate+0.75;
  if Result in [23..25] then AgressiveProjRate:=AgressiveProjRate+0.5;
  if Result = 50 then SleepingProjRate:=SleepingProjRate+1;

  if (AgressiveProjRate<>0) and (AGI^.TurnCount>2) then
   AgressionRate:=AgressiveProjRate/AGI^.TurnCount;
  if (SleepingProjRate>0) and (AGI^.TurnCount>2) then
   SleepingRate:=SleepingProjRate/AGI^.TurnCount;
end;

exports
  GetName, GetTurn, StartGame;

procedure DLLEntryPoint(dwReason:DWord);
var
  _i:integer;
  _Strat:TNamedList;
begin
  case dwReason of
   DLL_PROCESS_ATTACH:
    begin
     Randomize;
     StratKnowledgeBase:=TMemberList.Create;
    end;
   DLL_PROCESS_DETACH:
    begin
    { for _i:=0 to StratKnowledgeBase.Count-1 do
      begin
       _Strat:=StratKnowledgeBase.GetMember(_i);
       MessageBox(0,pchar(_Strat.GetName+#10#13+_Strat.GetAsStrArray()),'strat',0);
      end; }
     StratKnowledgeBase.Free;
    end;
   end;
end;

begin
   DllProc:= @DLLEntryPoint; 
   DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
 