
; DLL creation example

format PE GUI 4.0 DLL
entry DllEntryPoint

include 'win32a.inc'

include 'FortressCommonDefs.inc'

section '.code' code readable writeable executable

BotName db 'SimpleBot v1.3 AntiRUSH (ASM)',0

Projects:
       dd 5
       dd 6
       dd 8
       dd 11
       dd 14
       dd 15
       dd 18
       dd 20
       dd 28
       dd 33
       dd 34
       dd 35
       dd 41
       dd 42
       dd 46

RandSeed dd 0

Random:
;IN EAX   Range
;OUT EAX  Result
	push ebx
	push edx
	xor ebx, ebx
	imul edx, [RandSeed] ,08088405h
	inc edx
	mov [RandSeed], edx
	mul edx
	mov eax, edx
	pop edx
	pop ebx
	ret


IsProjectAvailProc:
;IN
; EDX = aProject
; ECX = aAvailProjects
;OUT
; EAX = 0 if project not avail
; EAX = -1 if project avail

     push ecx
     push ebx

     mov ebx, ecx
     mov ecx, 15
    .repeat:
     mov eax, ecx
     dec eax
     shl eax, 2
     add eax, ebx
     mov eax, [eax]
     cmp edx, eax
     jz .avail
     loop .repeat
     xor eax, eax
     jmp .exit
    .avail:
     xor eax, eax
     dec eax
    .exit:

     pop ebx
     pop ecx
     ret

proc DllEntryPoint hinstDLL, fdwReason, lpvReserved
	mov	eax, TRUE
	ret
endp

proc GetName

     mov eax, BotName
     ret

endp

proc StartGame aPlayerNumber, aAvailProjects, AGI

     pushad

     xor eax, eax
     cmp [aAvailProjects], eax
     jz .exit

     mov edi, [aAvailProjects]
     mov esi, Projects
     mov ecx, MaxProjectsToPlayer*4
     rep movsb

    .exit:
     popad
     ret
endp

macro IsProjectAvail arg1, arg2
{
   mov edx, arg1
   mov ecx, arg2
   call IsProjectAvailProc
   ;cmp eax, 0
}

proc GetTurn aPlayerNumber, aGame, aAvailProjects, AGI

     push ebx
     push edx
     push esi
     push edi


     cmp [aAvailProjects], 0
     jnz @f
     jmp .exit
    @@:

     mov ebx, [aPlayerNumber]
     imul ebx, ebx, PlayerInfoSize
     add ebx, [aGame]		     ; ebx = self base info
     virtual at ebx
      .ebx PlayerInfo
     end virtual

     mov esi, [AGI]		     ; esi = AGI
     virtual at esi
      .esi AdditionalGameInfo
     end virtual

     mov edi, [aPlayerNumber]
     xor edi, 1
     imul edi, edi, PlayerInfoSize
     add edi, [aGame]		     ; edi = opponent base info
     virtual at edi
      .edi PlayerInfo
     end virtual

    @@:

     IsProjectAvail 20, [aAvailProjects]
     jz @f
     cmp [.esi.TurnCount], 2
     jbe @f
     mov eax, [.ebx.Base]
     add eax, [.ebx.Shield]
     cmp eax, 20
     jae @f

     mov eax, 20
     jmp .exit
    @@:

     IsProjectAvail 15, [aAvailProjects]
     jz @f
     cmp [.esi.TurnCount], 2
     jbe @f
     mov eax, [.ebx.Shield]
     cmp eax, 3
     jae @f

     mov eax, 15
     jmp .exit
    @@:

     IsProjectAvail 41, [aAvailProjects]
     jz @f
     cmp [.esi.TurnCount], 3
     jae @f
     mov eax, [.edi.Metal]
     cmp eax, 3
     jbe @f

     mov eax, 41
     jmp .exit
    @@:

     IsProjectAvail 42, [aAvailProjects]
     jz @f
     cmp [.esi.TurnCount], 3
     jae @f
     mov eax, [.edi.Elements]
     cmp eax, 3
     jbe @f

     mov eax, 42
     jmp .exit
    @@:

     IsProjectAvail 34, [aAvailProjects]
     jz @f
     cmp [.ebx.Mines], 3
     jae @f
     mov eax, [.ebx.Base]
     add eax, [.ebx.Shield]
     cmp eax, 20
     jbe @f

     mov eax, 34
     jmp .exit
    @@:

     IsProjectAvail 33, [aAvailProjects]
     jz @f
     cmp [.ebx.Battery], 4
     jae @f
     mov eax, [.ebx.Base]
     add eax, [.ebx.Shield]
     cmp eax, 20
     jbe @f

     mov eax, 33
     jmp .exit
    @@:

     IsProjectAvail 35, [aAvailProjects]
     jz @f
     cmp [.ebx.Labs], 3
     jae @f
     mov eax, [.ebx.Base]
     add eax, [.ebx.Shield]
     cmp eax, 20
     jbe @f

     mov eax, 35
     jmp .exit
    @@:
     ;
     IsProjectAvail 34, [aAvailProjects]
     jz @f
     cmp [.ebx.Mines], 5
     jae @f
     mov eax, [.ebx.Base]
     cmp eax, 22
     jbe @f

     mov eax, 34
     jmp .exit
    @@:

     IsProjectAvail 33, [aAvailProjects]
     jz @f
     cmp [.ebx.Battery], 6
     jae @f
     mov eax, [.ebx.Base]
     cmp eax, 22
     jbe @f

     mov eax, 33
     jmp .exit
    @@:

     IsProjectAvail 35, [aAvailProjects]
     jz @f
     cmp [.ebx.Labs], 4
     jae @f
     mov eax, [.ebx.Base]
     cmp eax, 22
     jbe @f

     mov eax, 35
     jmp .exit
    @@:


     IsProjectAvail 46, [aAvailProjects]
     jz @f
     cmp [.edi.Shield], 5
     jbe @f

     mov eax, 46
     jmp .exit
    @@:


     IsProjectAvail 14, [aAvailProjects]
     jz @f
     mov eax, 14
     jmp .exit
    @@:

    @@:
     mov eax, 10
     call Random

     shl eax, 2
     add eax, [aAvailProjects]
     cmp dword [eax], 0
     jz @b
     mov eax, [eax]
    .exit:
     pop edi
     pop esi
     pop edx
     pop ebx
     ret

endp

section '.edata' export data readable

  export 'SimpleBotAsm.DLL',\
	 GetName, 'GetName', \
	 StartGame, 'StartGame', \
	 GetTurn, 'GetTurn'

section '.reloc' fixups data discardable
